"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function isPromise(value) {
    return value && value.then !== undefined;
}
function maybeAsync(fn) {
    let prev = undefined;
    for (const iter = fn();;) {
        const { value, done } = iter.next(prev);
        if (done)
            return value;
        if (isPromise(value))
            return resumeAsyncFn(value, iter);
        if (Array.isArray(value) && value.some(isPromise))
            return resumeAsyncFn(Promise.all(value), iter);
        prev = value;
    }
}
exports.maybeAsync = maybeAsync;
function resumeAsyncFn(value, iter) {
    return __awaiter(this, void 0, void 0, function* () {
        for (let prev = yield value;;) {
            const { value, done } = iter.next(prev);
            if (done)
                return value;
            if (isPromise(value)) {
                prev = yield value;
            }
            else if (Array.isArray(value) && value.some(isPromise)) {
                prev = yield Promise.all(value);
            }
            else {
                prev = value;
            }
        }
    });
}
exports.default = maybeAsync;
